<template>
  <div class="rui-badge" :class="componentCSS">
    <span v-if="icon || $slots.left">
      <!-- @slot Use this slot for custom icons (i.e.: with custom classes) -->
      <slot name="left"><rui-icon :name="icon" /></slot>
    </span>

    <!-- @slot Visible text -->
    <span v-if="caption || $slots.default"><slot>{{ caption }}</slot></span>

    <span v-if="endIcon || $slots.right">
      <!-- @slot Use this slot for custom icons (i.e.: with custom classes) -->
      <slot name="right"><rui-icon :name="endIcon" /></slot>
    </span>
  </div>
</template>

<script>
import RuiIcon from '../Icon/Icon.vue'

const variants = ['danger', 'success', 'warning', 'help', 'mute']
const sizes = ['small']

/**
 * This component is very similar to a tag, _but bigger_. It is meant to be used as a side piece of information about
 * the surrounding content, while tags are mostly used to categorize things.
 *
 * @preset Default { "props": { "caption": "10 new", "icon": "rui:asterisk", "variant": "help" } }
 * @propsGroup Display [inverse, size, variant]
 * @propsGroup Content [caption, icon, endIcon]
 */
export default {
  name: 'RuiBadge',
  components: { RuiIcon },
  props: {
    /** Text. Will be overridden by default slot content */
    caption: { required: false, type: [String, Number], default: null },
    /**
     * Color variant
     *
     * @values danger, success, warning, help, mute
     */
    variant: { required: false, type: String, default: null, validator: v => variants.includes(v) },
    /**
     * Button size
     *
     * @values small, large
     */
    size: { required: false, type: String, default: null, validator: v => sizes.includes(v) },
    /** Left icon name */
    icon: { required: false, type: String, default: null },
    /** Right icon name */
    endIcon: { required: false, type: String, default: null },
    /** Inverse colors */
    inverse: { required: false, type: Boolean, default: false },
  },
  computed: {
    componentCSS () {
      return [
        this.size && `rui-badge--${this.size}`,
        variants.includes(this.variant) && `rui-badge--${this.variant}`,
        this.inverse && 'rui-badge--inverse',
      ]
    },
  },
}
</script>
